/*******************************************************************************
*
* Filename  : tripapi.h
* Copyright : Smaser AG - all rights reserved
* Purpose   : C prototype header file for TRIPapi routines
* History   :
*	950701	GF	Removed automated creation process
*	950710	GF	Added prototypes for timer functions and updated all
*               to V3.1-2 specification.
*	011015	JS	Added new and removed old function prototypes
*	030606	GF	Updated to remove MS-DOS/Win16, remove conflicts with COM, etc.
*
*******************************************************************************/

#ifndef __TRIPapi_PROTOTYPES__
#define __TRIPapi_PROTOTYPES__

/* Include the kernel structure and constant definitions required */
#if !defined(__TRIPbase_H__)
#   include <tripbase.h>
#endif

#if defined(__cplusplus)
extern "C" {
#endif

/* Work out if prototypes are required / supported by the compiler */
#if defined(__cplusplus) || defined(_MSC_VER) || defined(__STDC__)
#	define _USE_TRIP_PROTOTYPES 1
#   define TRIPapi extern int
#else
#	define _USE_TRIP_PROTOTYPES 0
#endif

#if _USE_TRIP_PROTOTYPES
TRIPapi TdbAddMember(char*, char*);
TRIPapi TdbAppendRecordPart(TdbHandle, char*);
TRIPapi TdbAseRetCode(void);
TRIPapi TdbAssignTerminal(void);
TRIPapi TdbBaffitMode(void);
TRIPapi TdbBaseInfo(char*, int, char*, int*);
TRIPapi TdbBaseStatus(char*, char*, char*, int*);
TRIPapi TdbBatchLoadIndex(int, char*, char*);
TRIPapi TdbBeginBufOutput(void);
TRIPapi TdbBeginCriticalSection(void);
TRIPapi TdbBeginTdbs(shell_dao_rec*, boolean);
TRIPapi TdbBeginUtility(TdbHandle);
TRIPapi TdbBreak(void);
TRIPapi TdbCallAse(void*, char*, int*);
TRIPapi TdbCallUfoAse(int);
TRIPapi TdbCancelTimer(void);
TRIPapi TdbChangeFm(char*, char*, char*);
TRIPapi TdbChangePassword(char*, char*);
TRIPapi TdbChangeUm(char*, char*, char*);
TRIPapi TdbCharacterSet(char*);
TRIPapi TdbCheckBase(char*, int);
TRIPapi TdbCheckCcl(char*, int*);
TRIPapi TdbCheckCursor(TdbHandle, TdbHandle*, int*, int*, int*);
TRIPapi TdbCheckData(TdbHandle, int, int, char*, int);
TRIPapi TdbCheckDate(int, char*, int*);
TRIPapi TdbCheckDbCluster(char*, int);
TRIPapi TdbCheckEntryForm(void);
TRIPapi TdbCheckExistence(TdbHandle, int, char*, int);
TRIPapi TdbCheckField(TdbHandle, char*, int*, int*, int*);
TRIPapi TdbCheckFieldName(char*);
TRIPapi TdbCheckMember(char*, char*);
TRIPapi TdbCheckOutputFormat(void);
TRIPapi TdbCheckPartName(TdbHandle, int*, char*);
TRIPapi TdbCheckPicture(void);
TRIPapi TdbCheckRecordName(TdbHandle, int*, char*);
TRIPapi TdbCheckScreenWindow(int, int*);
TRIPapi TdbCheckSearch(int*);
TRIPapi TdbCheckSearchForm2(TdbHandle, int);
TRIPapi TdbCheckSelectRecord(int);
TRIPapi TdbCheckSymbol(int*, char*, int*);
TRIPapi TdbCheckTerminalType(int*);
TRIPapi TdbCheckThes(char*, int);
TRIPapi TdbCheckTime(int, char*, int*);
TRIPapi TdbCheckUfoAse(void);
TRIPapi TdbCheckUser(char*, char*, char*, char*, char*);
TRIPapi TdbClearRunStack(void);
TRIPapi TdbCloseAsciiFile(TdbHandle);
TRIPapi TdbCloseFile(TdbHandle);
TRIPapi TdbContinue(void);
TRIPapi TdbContinueEdit(TdbHandle);
TRIPapi TdbCopyBaseDef(char*, char*, base_spec_rec*);
TRIPapi TdbCopyEntryForm(char*, char*, char*, char*, int*);
TRIPapi TdbCopyOutputFormat(char*, char*, char*, char*, int*);
TRIPapi TdbCopyProcedure(char*, char*);
TRIPapi TdbCopySearchForm(char*, char*, int*);
TRIPapi TdbCopyThesDef(char*, char*, base_spec_rec*);
TRIPapi TdbCreateGroup(char*);
TRIPapi TdbCreateRecordControl(TdbHandle*);
TRIPapi TdbCreateTimeStamp(unsigned int*, int);
TRIPapi TdbCreateTermSet(int*);
TRIPapi TdbCreateUser(char*, char*);
TRIPapi TdbCurrentBase(char*);
TRIPapi TdbCurrentDate(char*, int*);
TRIPapi TdbCurrentForm(char*, char*, int);
TRIPapi TdbCurrentItem(char*, TdbHandle*, int*, int*, int*, int*, int*);
TRIPapi TdbCurrentTime(char*, int*);
TRIPapi TdbCursorInfo(TdbHandle, int, char*, int*);
TRIPapi TdbDaoOrder(int*);
TRIPapi TdbDeallocate(char*);
TRIPapi TdbDefineGraph(base_spec_rec*,boolean);
TRIPapi TdbDefineWindow(int, int, int);
TRIPapi TdbDefineXml(boolean);
TRIPapi TdbDeleteBaseDef(void);
TRIPapi TdbDeleteCursor(TdbHandle*);
TRIPapi TdbDeleteDbCluster(void);
TRIPapi TdbDeleteEntryForm(char*, char*);
TRIPapi TdbDeleteFieldSpec(field_spec_rec*);
TRIPapi TdbDeleteGroup(char*);
TRIPapi TdbDeleteItem(TdbHandle);
TRIPapi TdbDeleteMember(char*, char*);
TRIPapi TdbDeleteOutputFormat(char*, char*);
TRIPapi TdbDeleteProcedure(char*);
TRIPapi TdbDeleteRecordControl(TdbHandle*);
TRIPapi TdbDeleteRecordInBase(TdbHandle);
TRIPapi TdbDeleteRecordPart(TdbHandle, int);
TRIPapi TdbDeleteSearchForm(char*);
TRIPapi TdbDeleteTermSet(int);
TRIPapi TdbDeleteThesDef(void);
TRIPapi TdbDeleteUser(char*);
TRIPapi TdbDeleteWindow(int);
TRIPapi TdbDidYouMean(char*, int*);
TRIPapi TdbEditData(int);
TRIPapi TdbEditOutputFormat(void);
TRIPapi TdbEditProcedure(void);
TRIPapi TdbEndBufOutput(void);
TRIPapi TdbEndCriticalSection(void);
TRIPapi TdbEndDataEntry(void);
TRIPapi TdbEndFlags(void);
TRIPapi TdbEndTdbs(boolean);
TRIPapi TdbEndUtility(TdbHandle, int);
TRIPapi TdbEraseRecordControl(TdbHandle);
TRIPapi TdbError(int);
TRIPapi TdbExecuteCcl(char*, int*);
TRIPapi TdbExport(FilterData*);
TRIPapi TdbExportBlob(TdbHandle, char*);
TRIPapi TdbFieldHelp(int);
TRIPapi TdbFieldInfo(TdbHandle, int, char*, int*);
TRIPapi TdbFindSelectRecords(void);
TRIPapi TdbGetBaseDef(char*, base_spec_rec*);
TRIPapi TdbGetBaseInfo(char*, char*, int*);
TRIPapi TdbGetBlobBlock(TdbHandle, int, int, char*, int*);
TRIPapi TdbGetBlobSize(TdbHandle, int*);
TRIPapi TdbGetComment(char*);
TRIPapi TdbGetDao(int*, char**, int*);
TRIPapi TdbGetDbAccess(char*, base_access_rec*);
TRIPapi TdbGetDbCluster(char*, cluster_spec_rec*);
TRIPapi TdbGetDisplay(int*, int*);
TRIPapi TdbGetDisplayTerm(int, char*, int*, int*);
TRIPapi TdbGetEntryForm(char*, char*);
TRIPapi TdbGetFieldInfo(TdbHandle, int*, char**, int*, int**, int*);
TRIPapi TdbGetFieldName(field_spec_rec*, int);
TRIPapi TdbGetFieldSpec(field_spec_rec*);
TRIPapi TdbGetFormLine(char*, int*);
TRIPapi TdbGetFormatFlags(int, int*);
TRIPapi TdbGetGroup(char*, int*);
TRIPapi TdbGetGroupName(char*, int);
TRIPapi TdbGetHitPart(TdbHandle, int, int*);
TRIPapi TdbGetItem(TdbHandle, char*, int*);
TRIPapi TdbGetLine(TdbHandle, char*, int*, int);
TRIPapi TdbGetLinkBase(char*, char*);
TRIPapi TdbGetLinkRecord(TdbHandle, char*, int);
TRIPapi TdbGetMembers(char*, int*);
TRIPapi TdbGetNextHitWord(TdbHandle, int*, int*, int*, int*, int*, int*);
TRIPapi TdbGetNextItem(TdbHandle, char*, int*);
TRIPapi TdbGetNextProcLine(char**, int*);
TRIPapi TdbGetOutputFormat(char*, char*);
TRIPapi TdbGetParsedCcl(int, char**, int*);
TRIPapi TdbGetProcLine(char*, int*);
TRIPapi TdbGetProcedure(char*);
TRIPapi TdbGetQueuedMessage(char*, int*, char*);
TRIPapi TdbGetRecordBuffer(TdbHandle, char*, int, int, int*);
TRIPapi TdbGetRecordInBase(TdbHandle, int);
TRIPapi TdbGetRecordInSearch(TdbHandle, int*, int*, char*);
TRIPapi TdbGetRecordInSearchRis(TdbHandle, int*, int, int*, char*);
TRIPapi TdbGetRecordInThes(TdbHandle, int, int*);
TRIPapi TdbGetRunArg(char*, int*, char*);
TRIPapi TdbGetSearch(int*, int*, int*);
TRIPapi TdbGetSearchForm(char*);
TRIPapi TdbGetSelectRecord(int*, char*);
TRIPapi TdbGetSessionInfo(char*, char*, char*, char*, char*);
TRIPapi TdbGetSortedRecord(int, TdbHandle, int, int*, char*);
TRIPapi TdbGetTermSetTerm(int,int,char*,int*,int*);
TRIPapi TdbGetTextSeparators(text_sepa_rec*);
TRIPapi TdbGetThesDef(char*, base_spec_rec*);
TRIPapi TdbGetTimeStamp(TdbHandle, unsigned int*, int);
TRIPapi TdbGetUserProfile(char*, user_profile_rec*);
TRIPapi TdbGetUserRights(char*, boolean*, boolean*);
TRIPapi TdbGetWindowHit(int, int*, int*);
TRIPapi TdbGetWindowHits(int, int*, int**);
TRIPapi TdbGetWindowInfo(int, char**, int*, int*, int*, int*);
TRIPapi TdbGetWindowLine(int, char*);
TRIPapi TdbGetWindowType(int, int*);
TRIPapi TdbGraphAddVertex(TdbHandle*, const char*, const char*, TdbHandle);
TRIPapi TdbGraphFind(int*, int, int, int, int, const char*);
TRIPapi TdbGraphTransitive(int*,int, boolean, boolean, int, int, int, const char*);
TRIPapi TdbGraphGetPath(int*, char**, double*, char**, int*);
TRIPapi TdbGraphNextPath(int*, char**, int*);
TRIPapi TdbGraphRecAssoc(TdbHandle*,const char*,const char*,TdbHandle,TdbHandle,double);
TRIPapi TdbGraphResolve(int*, int, int, const char*);
TRIPapi TdbGraphStartPathAnalysis(int**,int,int,int,int,int,boolean,const char*);
TRIPapi TdbGraphPathAnalysisStep(int*);
TRIPapi TdbGraphAnalysisSnapshot(int*,int*,int);
TRIPapi TdbGraphClosePathAnalysis(int**);
TRIPapi TdbGraphQuery(int*, int*, int*, const char*);
TRIPapi TdbHelp(int);
TRIPapi TdbHitParts(TdbHandle, int*, int*, int*);
TRIPapi TdbImport(FilterData*);
TRIPapi TdbImportBlob(TdbHandle, char*);
TRIPapi TdbIndex(const char*, int);
TRIPapi TdbInitBifList(char*, char*, int);
TRIPapi TdbInsertItem(TdbHandle, char*, int);
TRIPapi TdbInsertRecordPart(TdbHandle, char*);
TRIPapi TdbIsSuperUser(void);
TRIPapi TdbItemCount(TdbHandle, int*);
TRIPapi TdbLanguage(char*);
TRIPapi TdbLoadAse(char*, void**);
TRIPapi TdbLoadStatus(int);
TRIPapi TdbLockBuffers(char*);
TRIPapi TdbLockRecord(TdbHandle);
TRIPapi TdbMessage(int, char*, int*);
TRIPapi TdbNextBifRecno(int*);
TRIPapi TdbNextBifTerm(char*, int*);
TRIPapi TdbNextControl(TdbHandle*);
TRIPapi TdbNextHitInWindow(int*, int*, int*);
TRIPapi TdbNextRunCommand(void);
TRIPapi TdbNextWindow(TdbHandle, int*, char*, int, int, int, int);
TRIPapi TdbOpenAsciiFile(TdbHandle*, char*, int);
TRIPapi TdbOpenBase(char*);
TRIPapi TdbOpenBaseQuota(int*);
TRIPapi TdbOpenFile(TdbHandle*, char*, int, int);
TRIPapi TdbOsUser(char*, int*);
TRIPapi TdbParaCount(TdbHandle, int*);
TRIPapi TdbPartCount(TdbHandle, int*);
TRIPapi TdbPauseTdbs(void);
TRIPapi TdbProcessMode(void);
TRIPapi TdbPromptInteger(char*, int, int, int, boolean);
TRIPapi TdbPromptString(char*, char*, int*, int, boolean, boolean);
TRIPapi TdbPromptYesno(char*, boolean, char, char);
TRIPapi TdbPutBaseDef(base_spec_rec*);
TRIPapi TdbPutBlobBlock(TdbHandle, int, char*);
TRIPapi TdbPutComment(char*);
TRIPapi TdbPutDbAccess(base_access_rec*);
TRIPapi TdbPutDbCluster(cluster_spec_rec*);
TRIPapi TdbPutEntryForm(void);
TRIPapi TdbPutFieldInfo(TdbHandle, int, char*);
TRIPapi TdbPutFieldSpec(field_spec_rec*);
TRIPapi TdbPutFormLine(char*, int);
TRIPapi TdbPutLine(TdbHandle, char*, int);
TRIPapi TdbPutOutputFormat(void);
TRIPapi TdbPutProcLine(char*, int);
TRIPapi TdbPutProcedure(void);
TRIPapi TdbPutRecord(TdbHandle, int*);
TRIPapi TdbPutRecordBuffer(TdbHandle, char*, int, int*, int*, int*);
TRIPapi TdbPutSearchForm(void);
TRIPapi TdbPutTextSeparators(text_sepa_rec*);
TRIPapi TdbPutThesDef(base_spec_rec*);
TRIPapi TdbPutUserProfile(user_profile_rec*);
TRIPapi TdbPutUserRights(boolean, boolean);
TRIPapi TdbRangeStart(int);
TRIPapi TdbRangeStop(int);
TRIPapi TdbReadChar(char*);
TRIPapi TdbReadAsciiFile(TdbHandle, char*, int*);
TRIPapi TdbReadFile(TdbHandle, char*, int);
TRIPapi TdbRecordInfo(TdbHandle, int, char*, int*);
TRIPapi TdbReformatRecord(void);
TRIPapi TdbRegisterKernelError(int);
TRIPapi TdbReleaseRecord(TdbHandle);
TRIPapi TdbRenameRecordPart(TdbHandle, char*);
TRIPapi TdbReplaceItem(TdbHandle, char*, int);
TRIPapi TdbResetSelectRecord(int);
TRIPapi TdbResumeTdbs(void);
TRIPapi TdbRetCode(void);
TRIPapi TdbSaveStatus(void);
TRIPapi TdbSearchMode(int*);
TRIPapi TdbSearchResult(int*, int*, int*, char**, int*);
TRIPapi TdbSessionInfo(int, char*, int*);
TRIPapi TdbSetBase(TdbHandle, char*, int);
TRIPapi TdbSetBreakChars(int, void(int), int);
TRIPapi TdbSetBreakFlag(void);
TRIPapi TdbSetClockInterval(int, void(int));
TRIPapi TdbSetComforterInterval(int, void(int));
TRIPapi TdbSetCursor(TdbHandle*, TdbHandle, int, int, int);
TRIPapi TdbSetEntryForm(char*);
TRIPapi TdbSetFormFlag(int);
TRIPapi TdbSetIntegerVariable(int, int);
TRIPapi TdbSetLinkBase(TdbHandle, char*, TdbHandle*);
TRIPapi TdbSetMacroLine(int);
TRIPapi TdbSetPassword(char*, char*);
TRIPapi TdbSetRecordPart(TdbHandle*, TdbHandle, int);
TRIPapi TdbSetScreenList(void*);
TRIPapi TdbSetScreenWindow(int, int);
TRIPapi TdbSetSelectRecord(int, int, int);
TRIPapi TdbSetTerminalType(int);
TRIPapi TdbSetTextVariable(int, char*);
TRIPapi TdbSformFd(shell_dao_rec*, int*, boolean);
TRIPapi TdbShellDaoPtr(shell_dao_rec**);
TRIPapi TdbShellDefDateform(int, char*);
TRIPapi TdbShellInit(int);
TRIPapi TdbShellModifyCcl(int);
TRIPapi TdbShellSelect(shell_dao_rec**, int, int, boolean);
TRIPapi TdbShellSymbol(char*, int*);
TRIPapi TdbShellToDao(shell_dao_rec*);
TRIPapi TdbShellType(char*, int*);
TRIPapi TdbShowControl(int, int, char*, char*);
TRIPapi TdbSortRecords(int, char*);
TRIPapi TdbStartClock(void);
TRIPapi TdbStartComforter(void);
TRIPapi TdbStartControl(char*);
TRIPapi TdbStartSelect(int*);
TRIPapi TdbStartTrip(char*, char*, int, int);
TRIPapi TdbStopClock(void);
TRIPapi TdbStopComforter(void);
TRIPapi TdbStopTrip(boolean);
TRIPapi TdbStrCompare(char*, char*, int, int);
TRIPapi TdbStrFindChar(char*, int, int*, char);
TRIPapi TdbStrFromInteger(char*, int*, int);
TRIPapi TdbStrLength(char*, int);
TRIPapi TdbStrMove(char*, char*, int);
TRIPapi TdbStrMovePad(char*, char*, int, int, char);
TRIPapi TdbStrNormalize(char*, int*, int);
TRIPapi TdbStrToInteger(char*, int*);
TRIPapi TdbSystemMode(char*);
TRIPapi TdbTdbsUser(char*, int*);
TRIPapi TdbUndeleteRecordPart(TdbHandle);
TRIPapi TdbUseEntryForm(int*, int*, int*);
TRIPapi TdbUserInfo(int, char*, int*);
TRIPapi TdbUseSearchForm(char*);
TRIPapi TdbValidValues(int, TdbHandle, char*);
TRIPapi TdbVersion(char*, int*);
TRIPapi TdbVmsUser(char*, int*);
TRIPapi TdbWriteAsciiFile(TdbHandle, char*, int);
TRIPapi TdbWriteFile(TdbHandle, char*, int);
TRIPapi TdbWritePicture(void);
TRIPapi TdbWriteString(char*, int);

TRIPapi TdbGetIntegrityRules(base_integrity_spec**);
TRIPapi TdbFreeIntegrityRules(base_integrity_spec*);
TRIPapi TdbDeleteIntegrityRules();
TRIPapi TdbCheckForeignKey(Char*, Char*, Char*);
TRIPapi TdbSetForeignKey(Char*, Char*, Char*, int, int);
TRIPapi TdbDeleteForeignKey(Char*);

TRIPapi TdbGetDefaultValue(Char*, Char*, int*);
TRIPapi TdbPutDefaultValue(Char*, Char*);
TRIPapi TdbDeleteDefaultValue(Char*);

TRIPapi TdbGetDefragStatus(Char*, boolean*, boolean*, boolean*);

TRIPapi TdbEnumerateSummarizationSubsystems(int*, Char*, int*);
TRIPapi TdbStartSummarization(void**, int);
TRIPapi TdbAccumulateSummarization(void*, TdbHandle);
TRIPapi TdbGenerateSummary(void*, Char**);
TRIPapi TdbEndSummarization(void*);

TRIPapi TdbGetFocus(TdbHandle, int*, Char**, int*, int**, int*, int);
TRIPapi TdbGetFocus2(TdbHandle, int*, Char**, int*, int**, int*, int, int, GetFocus2Options);

extern tServerInfo* TdbServerInfo();

TRIPapi TdbGetBuildInfo(int infotype,trip_variant* value);

#endif

#if defined(__cplusplus)
}
#endif

#endif

