# --- tdbsconf.awk ---
#
# This AWK script is called from the install script as in order
# to migrate TRIPsystem configuration settings during an upgrade
# installation.
#
BEGIN { TDBS_PRC = 0; TDBS_TRM = 0; TRIP_DEMO = 0; TRIP_TERM = 0;
        NON_PRIV = 0; TDBS_CFL = 0; TDBS_CFS = 0; TDBSLANG = ""; NOT_TDBS = 0;
        TDBS_LOG = 0; TDBS_SCRATCH = 0; TDBS_SIF = 0;
}
{ LINE = toupper($0); TDBS_REP = 0; TRIP_REP = 0; CSTR = ""; CSUB = "";
  EQ_INDX = index(LINE,"=");
  if (substr($1,1,1) != "#") {
    if (substr($1,1,1) == "[") { LEN_1 = length($1);
      SECT_NAME = toupper(substr($1,2,LEN_1-2));
      if (substr(SECT_NAME,1,7) == "NonPriv") { NON_PRIV = 1;
      } else {
        if (NON_PRIV == 1) {
          if (TDBS_PRC == 0) { printf("TDBS_PRC=%s/prc\n",TRIP_PATH);
                               TDBS_PRC = 1 }
          if (TDBS_TRM == 0) { printf("TDBS_TRM=%s/trm\n",TRIP_PATH);
                               TDBS_TRM = 1 }
          if (TDBSLANG == "") { CSTR = "ENG" } else { CSTR = TDBSLANG }
          if (TDBS_CFL == 0) { printf("TDBS_CONFLATOR_LANG=%s\n",CSTR);
                               TDBS_CFL = 1 }
          if (TDBS_CFS == 0) {
            printf("TDBS_CONFLATORS=%s/bin/tripstem.so\n",TRIP_PATH);
            TDBS_CFS = 1 }
          if (TRIP_DEMO == 0) { printf("TRIP_DEMO=%s/demo\n",TRIP_PATH);
                               TRIP_DEMO = 1 }
          if (TRIP_TERM == 0) { printf("TRIP_TERMINAL=vt200\n");
                               TRIP_TERM = 1 }
          NON_PRIV = -1;
        }
      }
    } else { EQ_INDX = index(LINE,"=");
      if (EQ_INDX > 0) {
        TDBS_INDX = index(LINE,"TDBS_");
        if ((TDBS_INDX == 0) && (NOT_TDBS == 0)) {
          if (TDBSLANG == "") { CSTR = "ENG" } else { CSTR = TDBSLANG }
          NOT_TDBS = 1;
        }
        if ((TDBS_INDX > 0) && (TDBS_INDX < EQ_INDX)) {
          CVAR = substr(LINE,TDBS_INDX+5,EQ_INDX-(TDBS_INDX+5));
          CVAL = substr(LINE,EQ_INDX+1)
          if (length(CVAL)>0 && substr(CVAL,length(CVAL)) == "/") {
            CVALNOSLASH = substr(CVAL,0,length(CVAL)-1) }
          else { CVALNOSLASH = CVAL; }
          if (CVAR == "CTL") { TDBS_REP = 1; CDIR = "sys";
          } else {
            if (CVAR == "EXE") { TDBS_REP = 1; CDIR = "bin";
            } else {
              if (CVAR == "SYS") { TDBS_REP = 1; CDIR = "sys";
              } else {
                if (CVAR == "LOG") {
                  TDBS_LOG = 1;
                  if (toupper(OLD_PATH "/log") == toupper(CVALNOSLASH)) { TDBS_REP = 1; CDIR = "log"; }
                } else {
                  if (CVAR == "SCRATCH") {
                     TDBS_SCRATCH = 1;
                     if (toupper(OLD_PATH "/log") == toupper(CVALNOSLASH)) { TDBS_REP = 1; CDIR = "log"; }
                  } else {
                    if (CVAR == "SIF") {
                     TDBS_SIF = 1;
                     if (toupper(OLD_PATH "/log") == toupper(CVALNOSLASH)) { TDBS_REP = 1; CDIR = "log";  }
                    } else {
                      if (CVAR == "PRC") { TDBS_REP = 1; CDIR = "prc"; TDBS_PRC = 1;
                      } else {
                        if (CVAR == "TRM") { TDBS_REP = 1; CDIR = "trm"; TDBS_TRM = 1;
                        } else {
                          if (CVAR == "LANG") { TDBSLANG = substr(LINE,EQ_INDX+1,3);
                          } else {
                            if (CVAR == "CONFLATOR_LANG") { TDBS_CFL = 1;
                            } else {
                              if (CVAR == "CONFLATORS") { TDBS_REP = 2; TDBS_CFS = 1;
                                CDIR = "bin/tripstem.so"; CNDX = index(LINE,":");
                                if (CNDX > 0) {
                                  CSUB = substr(LINE,EQ_INDX+1,CNDX-EQ_INDX) }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        } else { TRIP_INDX = index(LINE,"TRIP_");
          if ((TRIP_INDX > 0) && (TDBS_INDX < EQ_INDX)) {
            CVAR = substr(LINE,TRIP_INDX+5,4);
            if (CVAR == "DEMO") { TRIP_REP = 1; CDIR = "demo"; TRIP_DEMO = 1;
            } else {
              if (substr(LINE,TRIP_INDX+5,8) == "TERMINAL") { TRIP_TERM = 1 }
            }
          }
        }
      }
    }
    if (TDBS_REP > 0) { CLIN = "TDBS_" CVAR "=";
      if (TDBS_REP == 1) { CLIN = CLIN TRIP_PATH "/" CDIR;
      } else { CLIN = CLIN CSUB TRIP_PATH "/" CDIR }
    } else {
      if (TRIP_REP == 1) { CLIN = "TRIP_" CVAR "=" TRIP_PATH "/" CDIR }
    }
  }
  if ((TDBS_REP > 0) || (TRIP_REP == 1)) { printf("%s\n",CLIN)
  } else { print $0 }
}
END { if (TDBS_LOG == 0) { printf("TDBS_LOG=%s/log\n",TRIP_PATH) }
      if (TDBS_SCRATCH == 0) { printf("TDBS_SCRATCH=%s/log\n",TRIP_PATH) }
      if (TDBS_SIF == 0) { printf("TDBS_SIF=%s/log\n",TRIP_PATH) }
      if (TDBS_PRC == 0) { printf("TDBS_PRC=%s/prc\n",TRIP_PATH) }
      if (TDBS_TRM == 0) { printf("TDBS_TRM=%s/trm\n",TRIP_PATH) }
      if (TDBSLANG == "") { CSTR = "ENG" } else { CSTR = TDBSLANG }
      if (TDBS_CFL == 0) { printf("TDBS_CONFLATOR_LANG=%s\n",CSTR) }
      if (TDBS_CFS == 0) {
        printf("TDBS_CONFLATORS=%s/bin/tripstem.so\n",TRIP_PATH) }
      if (TRIP_DEMO == 0) { printf("TRIP_DEMO=%s/demo\n",TRIP_PATH) }
      if (TRIP_TERM == 0) { printf("TRIP_TERMINAL=vt200\n") }
}
